There are two main categories of data types in Verilog. These categories differ in the underlying hardware structure they represent, and they differ in the way they are assigned and retain values.
# Nets
A *net* refers to a *network* of connections that join two or more devices together.

Nets connect different hardware entities and *do not store values*. 
## Wire
A `wire` is the most commonly used type of net. When a port is declared in Verilog, it is implicitly given a type of `wire`.

It is illegal to re-declare a name already in use by a net:
```verilog
module foo;
	wire abc;
	wire a;
	wire b;
	wire c;

	wire abc; // ILLEGAL: The wire `abc` is already defined

```

# Variables
A variable is a data storage element. They retain the last impu
# Scalar and Vector Types
